leetcode-501-Find-Mode-in-Binary-Search-Tree

描述


Given a binary search tree (BST) with duplicates, find all the mode(s)) (the most frequently occurred element) in the given BST.

Assume a BST is defined as follows:

  • The left subtree of a node contains only nodes with keys less than or equal to the node’s key.
  • The right subtree of a node contains only nodes with keys greater than or equal to the node’s key.
  • Both the left and right subtrees must also be binary search trees.

For example:
Given BST [1,null,2,2],

1
2
3
4
5
1
\
2
/
2

return [2].

Note: If a tree has more than one mode, you can return them in any order.

Follow up: Could you do that without using any extra space? (Assume that the implicit stack space incurred due to recursion does not count).

分析


求二分搜索树中的众数,因为二分搜索树的节点值是有序的,所以遍历一遍就够了,不需要使用哈希列表,要注意的是这道题有可能出现多个众数。

解决方案1(Java)


1
2
3
4
5
6
7
8
9
10
11
12
13
14
15
16
17
18
19
20
21
22
23
24
25
26
27
28
29
30
31
32
33
34
35
36
37
38
39
40
41
42
43
44
45
46
47
48
49
50
51
/**
* Definition for a binary tree node.
* public class TreeNode {
* int val;
* TreeNode left;
* TreeNode right;
* TreeNode(int x) { val = x; }
* }
*/
class Solution {
Integer prevNode = null;
int count = 1;
int nowMax = 0;

public int[] findMode(TreeNode root) {
if (root == null) {
return new int[0];
}
List<Integer> list = new ArrayList<>();
inOrder(root, list);
int[] result = new int[list.size()];
for (int i = 0; i < list.size(); i++) {
result[i] = list.get(i);
}
return result;
}

private void inOrder(TreeNode root, List<Integer> list) {
if (root == null) {
return;
}
inOrder(root.left, list);
if (prevNode != null) {
if (prevNode == root.val) {
count++;
} else {
count = 1;
}
}

if (count > nowMax) {
nowMax = count;
list.clear();
list.add(root.val);
} else if (count == nowMax) {
list.add(root.val);
}
prevNode = root.val;
inOrder(root.right, list);
}
}

相关问题


题目来源